#include <math.h>
#include "mex.h"

/* place in u the result of multiplying sparse(I+1,J+1,a) by vector v  */

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  double *u, *v, *I, *J, *a;
  mwSize nu, ni, nj, na, nv, i, ii, jj;
    
  if (nrhs != 5) mexErrMsgTxt("Five input arguments required.");
  nu = mxGetNumberOfElements(prhs[0]);      /* length of u */
  ni = mxGetNumberOfElements(prhs[1]);      /* length of I */
  nj = mxGetNumberOfElements(prhs[2]);      /* length of J */
  na = mxGetNumberOfElements(prhs[3]);      /* length of a */
  nv = mxGetNumberOfElements(prhs[4]);      /* length of v */
  
  if ((ni != nj) || (nj != na)) 
      mexErrMsgTxt("Bad I/J/a dimensions.");
  u = mxGetPr(prhs[0]);
  I = mxGetPr(prhs[1]);
  J = mxGetPr(prhs[2]);
  a = mxGetPr(prhs[3]);
  v = mxGetPr(prhs[4]);
  for (i = 0; i < nu; i++) u[i] = 0.0;
  for (i = 0; i < ni; i++) {
      ii = (mwSize)I[i];
      jj = (mwSize)J[i];
      /* if ((ii<0) || (ii>=nu) || (jj<0) || (jj>=nv))
          mexErrMsgTxt("Index out of bounds.");  */
      u[ii] += a[i]*v[jj];
  }
}