#include <math.h>
#include "mex.h"

/* update values of non-zero entries in a real sparse matrix s
   by the entries of v*/

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  double *s, *v;
  mwSize ns, nv, i;
    
  if (nrhs != 2) mexErrMsgTxt("Two input arguments required.");
  ns = mxGetJc(prhs[0])[mxGetN(prhs[0])];   /* nnz of s */
  nv = mxGetNumberOfElements(prhs[1]);      /* length of v */
  if (ns != nv) mexErrMsgTxt("Wrong number of elements to update.");
  s = mxGetPr(prhs[0]);
  v = mxGetPr(prhs[1]);
  for (i = 0; i < ns; i++) s[i] = v[i];
}